<?php
require_once('facebook_app.php');
require_once('config.php');
require_once('vb_api_client.php');
$app = FacebookApp::instance();

$facebook = $app->getFacebookInterface();

$me = $facebook->api('/me');

$email = "data-hint='Email'";
$name = "data-hint='Username'";
if(!empty($me['name'])) {
    $name = 'value="'.$me['name'].'"';
}
if(!empty($me['email'])) {
    $email = 'value="'.$me['email'].'"';
}

$jsonRegister = json_decode(VBApiClient::instance()->call_cached("register", array(), array()), true);
$reqBirthday = 0;
$checkdate = 0;
$checkDate = $jsonRegister['vboptions']['usecoppa'];
$reqBirthday = @$jsonRegister['show']['birthday'];
$months = array(
                '01' => 'January', '02' => 'February', '03' => 'March', '04' => 'April',
                '05' => 'May', '06' => 'June', '07' => 'July', '08' => 'August', '09' => 'September',
                '10' => 'October', '11' => 'November', '12' => 'December'
               );

function getRequiredFields($json){
    if(!empty($json['response']['customfields_option']))
        printRequiredFields($customFieldsArray = $json['response']['customfields_option']);
    if(!empty($json['response']['customfields_profile']))
        printRequiredFields($json['response']['customfields_profile']);
}

function printRequiredFields($customFieldsArray){
    $html = '';
    if(array_key_exists('0', $customFieldsArray)){
        foreach($customFieldsArray as $customField){
           if($customField['custom_field_holder']['profilefield']['required'] == 2 || $customField['custom_field_holder']['profilefield']['required'] == 0)
               continue;
            $html .= buildRequiredFieldHtml($customField['custom_field_holder']);
        }
    }else{
        if($customFieldsArray['custom_field_holder']['profilefield']['required'] == 1 || $customFieldsArray['custom_field_holder']['profilefield']['required'] == 3)
            $html = buildRequiredFieldHtml($customFieldsArray['custom_field_holder']);
    }
    echo $html;
}

function buildRequiredFieldHtml($json){

    $type = $json['profilefield']['type'];
    $name = $json['profilefieldname'];
    $title = $json['profilefield']['title'];
    $label = '<label for="' . $name .'" class="label_form">' . $title . ':</label>';
    $html = $label;
    
    switch($type){
        case 'input': 
            $html .= '<input type="text" name="' . $name .'" id="' . $name . '" />';
        break;
        case 'textarea':
            $html .= '<textarea name="' . $name .'" id="' . $name . '" rows="4" cols="60"></textarea>';
        break;
        case 'select_multiple':
        case 'select':
            $html .= '<select id="' . $name .'" name="' . $name . '" ' . (($type == 'select_multiple')? 'multiple="multiple" size="5"' : '') . '>';

            $selectbits = $json['selectbits'];
            if(!array_key_exists('0', $selectbits)){
                $html .= '<option value="' . $selectbits['key'] . '" ';
                $html .= ((!empty($optionInfo['selected']))? 'selected="selected"' : '') . '>' . $selectbits['val'] . '</option>';
            }else{
                foreach($selectbits as $optionInfo){
                    $html .= '<option value="' . $optionInfo['key'] . '" ';
                    $html .= ((!empty($selectbits['selected']))? 'selected="selected"' : '') . '>' . $optionInfo['val'] . '</option>';
                }
            }
            $html .= '</select>';
        break;
        case 'checkbox':
        case 'radio':
            $html .= '<ul class="register_' . $type . '_buttons">';

            $radiobits = $json['radiobits'];
            if(!array_key_exists('0', $radiobits)){
                $html .= '<li class="register_li_' . $type .'">';
                $html .= '<label class="register_label_radio">';
                $html .= '<input type="' . $type . '" name="' . $name . '" value="' . $radiobits['key'] . '" id="' . $type . '_' . $name . '_0" ';
                $html .= ((!empty($radiobits['checked']))? 'checked="checked"' : '') . ' />&nbsp;' . $radiobits['val'] . '</label></li>';
            }else{
                $i = 0;
                foreach($radiobits as $optionInfo){
                    $html .= '<li class="register_li_' . $type . '">';
                    $html .= '<label class="register_label_radio">';
                    $html .= '<input type="' . $type . '" name="' . $name . '" value="' . $optionInfo['key'] . '" id="' . $type . '_' . $name . '_' . $i . '" ';
                    $html .= ((!empty($optionInfo['checked']))? 'checked="checked"' : '') . ' />&nbsp;' . $optionInfo['val'] . '</label></li>';
                }
            }
            $html .= '</ul>';
        break;
    }
    return '<div class="div_profile_field">' . $html . "</div>";
}

display_header();
?>
<div id="dbcontent">
    <div id="box_view">
        <script type='text/javascript'>
        $(function()
        {
            $('#register_form').submit (function()
            {
                var data = {};
                data['signed_request'] = window.signed_request;
                data['usecoppa'] = '<?php echo $checkDate ?>';
                $('#register_form input, #register_form textarea').each (function() {
                    data[$(this).attr('name')] = $(this).attr('value');
                });
		data[$("#year").attr("name")] = $("#year").attr("value");
		
		$('select').each(function(){
		    var name = $(this).attr("name");
		    var options = "";
		    var separator = "";
		    $('#' + name + ' option:selected').each(function(){
			 options += separator + $(this).val();
			 separator = ",";
		    });
                    data[name] = options;
                });
		
		var name_aux = "";
		var sep = "";
		var checked_values = "";
		$('input:checked').each(function(){
		    var name = $(this).attr("name");
		    var value = $(this).val();
		    if(name == name_aux){
		       if(data[name] == '')
		       	data[name] = value;
		       else{
			  data[name] += ',' + value;
		       }
		    }else{
			data[name] = value;
		    }
		    name_aux = name;
		});
                $.ajax({
                    dataType: 'json', 
                    type: 'POST', 
                    url: 'register.php',
                    cache: false,
                    data: data,
                    success: function(data, textStatus, jqXHR){
                        $('#register_form .message').slideUp(200);
                        var messageSelect = '#register_form .normal';
                        if(data.error) {
                            var messageSelect = '#register_form .error';
                        }
                        $(messageSelect).html(data.message).slideDown(200);
                        if(data.redirect) {
                        <?php if(VBApiClient::instance()->getVBMajorVersion() == 3) { ?>
                            var data = {};
                            data['signed_request'] = window.signed_request;
                            $('#register_form input').each (function() {
                                data[$(this).attr('name')] = $(this).attr('value');
                            });

                            $.ajax( {
                                dataType: 'json', 
                                type: 'POST', 
                                url: '<?php echo FACEBOOK_APP_SITEURL . "login.php"; ?>',
                                cache: false,
                                data: data,
                                success: function(data, textStatus, jqXHR){
                                    $('#login_form .message').slideUp(200);
                                    var messageSelect = '#login_form .normal';
                                    if(data.error) {
                                        var messageSelect = '#login_form .error';
                                    }
                                    $(messageSelect).html(data.message).slideDown(200);
                                    if(data.redirect) {
                                        setTimeout(function() {
                                             top.location.href = '<?php echo FACEBOOK_CANVAS_URL . (isset($_GET['redirect']) ? $_GET['redirect'] : '') ?>';
                                        }, 3000);                      
                                    }                       
                                },
                                error: function (xhr, textStatus, errorThrown) {
                                    $('#login_form .error').html('Unspecified error, please try again later.');
                                }
                            });
                            <?php } else { ?>
                            setTimeout(function() {
                                 top.location.href = '<?php echo FACEBOOK_CANVAS_URL . (isset($_GET['redirect']) ? $_GET['redirect'] : '') ?>';
                            }, 3000);
                            <?php } ?>                            
                        }                       
                    },
                    error: function (xhr, textStatus, errorThrown) {
                        $('#register_form .error').html('Unspecified error, please try again later.');

                    }
                });
                return false;
            });	
            $('#login_form').submit (function()
            {
                var data = {};
                data['signed_request'] = window.signed_request;
                $('#login_form input').each (function() {
                    data[$(this).attr('name')] = $(this).attr('value');
                });

                $.ajax( {
                    dataType: 'json', 
                    type: 'POST', 
                    url: '<?php echo FACEBOOK_APP_SITEURL . "login.php"; ?>',
                    cache: false,
                    data: data,
                    success: function(data, textStatus, jqXHR){
                        $('#login_form .message').slideUp(200);
                        var messageSelect = '#login_form .normal';
                        if(data.error) {
                            var messageSelect = '#login_form .error';
                        }
                        $(messageSelect).html(data.message).slideDown(200);
                        if(data.redirect) {
                            setTimeout(function() {
                                 top.location.href = '<?php echo FACEBOOK_CANVAS_URL . (isset($_GET['redirect']) ? $_GET['redirect'] : '') ?>';
                            }, 3000);                      
                        }                       
                    },
                    error: function (xhr, textStatus, errorThrown) {
                        $('#login_form .error').html('Unspecified error, please try again later.');
                    }
                });
                return false;
            });	
        }
        );
        </script>
        <div class="category_box">
            <div class="category_header">
                <div style="background: white url('_img/ico_all.png') no-repeat top left;" class="icon"></div>
                <div class="text"><span class="first">Login / Register</span></div>
            </div>
            <?php if(VBApiClient::instance()->getVBMajorVersion() == 4) { ?>
            <div class="register_page_title">Already a Member?</div><hr class="register_hr" />
            <div class="text_content">
                <p>
                    Sorry, we were unable to log you in automatically. Please make sure your forum account is linked to
                your Facebook account via Facebook Connect button on <a href="<?php echo vB_SITE_ROOT; ?>"><?php echo FACEBOOK_APP_NAME ?></a>.
                </p>
                <p>
                    If you are not a member, please create a new account.
                </p>
            </div>
            <?php } else { ?>
            <div class="register_page_title">Login</div><hr class="register_hr" />
            <form id="login_form" class='register'>
                <label for="username" class="label_form">Username:</label>
                <input type='text' name='username' id='username' <?php echo $name; ?> />
       
                <label for="password" class="label_form">Password:</label>
                <input type='password' name='password' id='password' value="" />
       
                <input type='submit' name='submit' value='Login' />
                <div class="message error"></div>
                <div class="message normal"></div>
                <div class="clear"></div>
            </form>
            <?php } ?>
            <div class="register_page_title">Create a new account</div><hr class="register_hr" />
            <?php if($checkDate || $reqBirthday){?>
                <div class="checkdate">
                    <p for="birthdate" id="labeldate">Date of birth:</p>
                    <div class="dateBox">
                        <label for="month">Month:</label>
                        <select name="month" id="month">
                            <?php foreach($months as $monthKey => $monthValue){ echo "<option value='" . $monthKey ."'>" . $monthValue . "</option>"; } ?>
                        </select>
                    </div>
                    <div class="dateBox">
                        <label for="day">Day:</label>
                        <select name="day" id="day">
                            <?php for($i = 1; $i<=31 ; $i++ ){ echo "<option value='" . str_pad($i,2,'0',STR_PAD_LEFT) ."'>" . $i . "</option>"; } ?>
                        </select>
                    </div>
                    <div class="dateBox">
                        <label for="year">Year:</label>
                        <input type="text" name="year" id="year" />
                    </div>
                </div>
            <?php } ?>
            <div class="clear"></div>
	    <form id="register_form" class='register'>
                <label for="username" class="label_form">Username:</label>
                <input type='text' name='username' id='username' <?php echo $name; ?> />
       
                <label for="password" class="label_form">Password:</label>
                <input type='password' name='password' id='password' value="" />

                <label for="email" class="label_form">Email:</label>
                <input type='text' name='email' id='email' <?php echo $email; ?> />
                <?php getRequiredFields($jsonRegister); ?>
                <input type='submit' name='submit' value='Register' />
                <div class="message error"></div>
                <div class="message normal"></div>
                <div class="clear"></div>
            </form>
            <div class="category_shadow">
                <div class="category_shadow_left"></div>
                <div class="category_shadow_center"></div>
                <div class="category_shadow_right"></div>
            </div>
        </div>
        <div class="clear"></div>
    </div>
</div>
<?php display_footer(0); ?>